Subject: Re: bug#32345: 12.1.1; wrong preview position for four-byte utf-8 encoded character (xelatex)

From: jfbu <[email-masked]>
Date: Thu, 2 Aug 2018 15:06:26 +0200

Le 02/08/2018 à 14:24, jfbu a écrit :
> Le 02/08/2018 à 14:13, David Kastrup a écrit :
>> jfbu <[email-masked]> writes:
>>
>>> Le 02/08/2018 à 13:34, David Kastrup a écrit :
>>>> jfbu <[email-masked]> writes:
>>>>
>>>>> I obtain partial success with
>>>>>
>>>>> \documentclass{article}
>>>>> \usepackage{unicode-math}
>>>>> \begin{document}
>>>>>
>>>>> Test: $𝒞$
>>>>>
>>>>> \end{document}
>>>>
>>>> [...]
>>>>
>>>>> Further the log contains indication something went wrong indeed
>>>>>
>>>>> l.5 Test: $
>>>>>              풞$
>>>>> Preview: Tightpage -32891 -32891 32891 32891
>>>>> ./testpreview.tex:5: Preview: Snippet 1 ended.(456786+9830x428605).
>>>>
>>>> Maybe you should bother to mention what you consider "indication
>>>> something went wrong indeed".  preview-latex produces error messages on
>>>> purpose.  That's the only way to get to the right column.
>>>>
>>>> The problem here is that the character in the error message appears to
>>>> be a different character from what is in the source file, so
>>>> preview-latex isn't able to correlate it with the source.
>>>>
>>>
>>> So you do understand what I meant then?
>>
>> No.  I am explaining what the log file content means.  There is nothing
>> in your posting suggesting that this was what you were trying to convey
>> and I do not consider it likely that a majority of readers of this
>> report would have been able to properly see the problem.
> 
> The extract from the log file is as in OP's initial post and
> the fact that the displayed character is wrong was already
> pointed out there, with even the precision that its codepoint #xd49e
> was like original character except for missing 1 most significative byte.
> 
>>
>>> Have a nice summer
>>
>> Does that mean that I should refrain from answers on this list in the
>> next few months or that you chose to put me into your kill file?  If you
>> expect others to read between the lines, those would be the two most
>> obvious interpretations of that line.
> 
> It meant I intended to refrain from participating to this list which
> appears somewhat hostile.  But anyway I am off-line from Internet
> for most of the summer so this was easily said by me somewhat too
> quickly possibly.
> 
>>
>> Just stating what one wants to say tends to make particularly electronic
>> communication less troublesome for everybody involved since the usual
>> cues in face-to-face communication are not available.
>>
>> All the best,
>>
> 
> The very same document with lualatex in place of xelatex seems
> to not experience the same problem, so there might be something
> specific to xelatex tokenization of UTF-8 and how it interferes
> with the preview-latex hack into $.
> 
> I am incompetent for any other remark,

beyond this:

consider (Plain) xetex file testerrorxetex.tex

\font\1="[latinmodern-math.otf]"
\1
\undefined 𝒞
\bye

Run xetex on it from Emacs buffer, the log file is

This is XeTeX, Version 3.14159265-2.6-0.99999 (TeX Live 2018) (preloaded format=xetex 2018.7.31)  2 AUG 2018 15:03
entering extended mode
  restricted \write18 enabled.
  file:line:error style messages enabled.
  %&-line parsing enabled.
**testerrorxetex.tex
(./testerrorxetex.tex
./testerrorxetex.tex:3: Undefined control sequence.
l.3 \undefined
                풞
The control sequence at the end of the top line
of your error message was never \def'ed. If you have
misspelled it (e.g., `\hobx'), type `I' and the correct
spelling (e.g., `I\hbox'). Otherwise just continue,
and I'll forget about whatever was undefined.

[1] )
Output written on testerrorxetex.pdf (1 page).

There is a problem here with xetex error logs.

Best

Jean-François